/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.io.IOException;
import java.net.URL;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JEditorPane;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import mathgraph32.MtgFrame;
import mathgraph32.MtgImageIcon;

@SuppressWarnings("serial")
public class AboutDlg extends MtgDlg {
  private JButton btnFermer;
  private JEditorPane ep;
  
  public AboutDlg(MtgFrame frameInit) {
    super(getString("aboutDlg1"), true, frameInit);
    initComponents();
  }
  
  private void initComponents() {
 		getContentPane().setLayout(new BorderLayout());
  	btnFermer = new MtgButton(frame, getString("btnFermer"));
  	btnFermer.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        dispose();
      }
    });
   	// On charge l'image de Splash Screen
    URL adr = MtgFrame.class.getResource("images/SplashScreen.png");
		double k = MtgFrame.screenIsHighResolution ? 2 : 1;
    ImageIcon imic = new MtgImageIcon(k, adr); // Modifi version 5.0 pour tenir compte crans haute dfinition
    JLabel labelImage = new JLabel();
    labelImage.setIcon(imic);
  	// On lit le fichier de licence
  	adr = MtgFrame.class.getResource("images/Licence.htm");
  	try {
			ep = new JEditorPane(adr);
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
   	
    // taLicence.setPreferredSize(new Dimension(labelImage.getWidth(), 200));
		JScrollPane scrollPane = new JScrollPane(ep, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
				JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
  	scrollPane.setPreferredSize(new Dimension(labelImage.getWidth(), (int)(k*250)));
  	getContentPane().add(labelImage, "North");
    getContentPane().add(scrollPane, "Center");
    JPanel paneSouth = new JPanel();
    paneSouth.add(btnFermer);
    getContentPane().add(paneSouth, "South");
    pack();
  }

}
