/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import java.awt.Dimension;
import java.awt.FlowLayout;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import mathgraph32.MtgFrame;

@SuppressWarnings("serial")
public class ChoixModificationImageDlg extends MtgDlg {
  private MtgButton btnCancel;
  private MtgButton btnOK;
  private javax.swing.ButtonGroup btnGroup;
  private MtgRadioButton radioModificationMultiple; // Si l'utilisateur fait le choix que la modification d'une image s'appliquera
	//  toutes les autres images
	private MtgRadioButton radioModificationUnique; // Si l'utilisateur fait le choix que la modification d'une image s'appliquera
	// la seule image clique
	private MtgLabel label1;
	private MtgLabel label2;
	private MtgLabel label3;
  private javax.swing.JPanel paneLeft;
  private javax.swing.JPanel paneRight;
  private javax.swing.JPanel panePrincipal;	
	/** Constructeur */
	public ChoixModificationImageDlg(MtgFrame frameInit) {
    super(getString("ch103"), true, frameInit);
    label1 = new MtgLabel(frame, getString("choixModificationImageDlg1"));
    label2 = new MtgLabel(frame, getString("choixModificationImageDlg2"));
    label3 = new MtgLabel(frame, getString("choixModificationImageDlg3"), JLabel.LEFT);
    radioModificationMultiple = new MtgRadioButton(frame, getString("choixModificationImageDlg4"));
    radioModificationUnique = new MtgRadioButton(frame, getString("choixModificationImageDlg5"));
    paneLeft = new javax.swing.JPanel();
    paneRight = new javax.swing.JPanel();
    panePrincipal = new javax.swing.JPanel();
    btnOK = new MtgButton(frame, getString("btnOK"));
    btnOK.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnOKActionPerformed(evt);
      }
    });    
    btnCancel = new MtgButton(frame, getString("btnCancel"));
    btnCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnCancelActionPerformed(evt);
      }
    });
    btnOK.setMaximumSize(btnCancel.getPreferredSize());
    btnGroup = new ButtonGroup();
    btnGroup.add(radioModificationMultiple);
    btnGroup.add(radioModificationUnique);
    paneLeft.setLayout(new BoxLayout(paneLeft, BoxLayout.Y_AXIS));
    paneRight.setLayout(new BoxLayout(paneRight, BoxLayout.Y_AXIS));
    paneLeft.add(label1);
    paneLeft.add(label2);
    paneLeft.add(label3);
    paneLeft.add(radioModificationMultiple);
    paneLeft.add(radioModificationUnique);
    radioModificationMultiple.setSelected(true);
    paneRight.add(btnOK);
    paneRight.add(Box.createRigidArea(new Dimension(0,5)));
    paneRight.add(btnCancel);
    panePrincipal.setLayout(new FlowLayout());
    panePrincipal.add(paneLeft);
    panePrincipal.add(paneRight);
    setContentPane(panePrincipal);
    pack();        
	}
  private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) { 
  	setRetourOK(false);
    dispose ();
  }                                         

  private void btnOKActionPerformed(java.awt.event.ActionEvent evt) {                                      
    // Si la rponse est valide, on ferme la boite de dialogue sans la dtruire.
    //setVisible(false); 
    dispose();
    //La boite de dialogue existera toujours ce qui permettra de connaitre le contneu
    // de retourOK
    setRetourOK(true);
  }
  
  public final boolean getModificationMultiple() {
  	return radioModificationMultiple.isSelected();
  }

}
