/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import objets.CListeObjets;
import objets.CValeurDynamique;
import types.Bool;
import types.FonteNom;
import mathgraph32.MtgFrame;

@SuppressWarnings("serial")
/**
 * Classe servant  diter un nom reprsentant une valeur relle ou complexe dj existante
 * L'initul doit correspondre  une valeur dont l'indice dans la liste des objets crs soit
 * infrieur  indiceMax
 */
public class EditeurIntituleValeurReelleOuComplexe extends MtgTextField {
  protected MtgFrame frame;
  private int indiceMaxi;
  CValeurDynamique pointeurValeur;
	public EditeurIntituleValeurReelleOuComplexe(MtgFrame frameInit, int indiceMaxiInit) {
		super(frameInit, 8);
		frame = frameInit;
		indiceMaxi = indiceMaxiInit;
		pointeurValeur = null;
		setFont(FonteNom.getFonteEdition(MtgFrame.sizeFontEditor, FonteNom.Normal,
				(double)frame.pref_addSystemFont/MtgFrame.sizeFontEditor + MtgFrame.coefMultForSystemFonts));				
	}
	
	public final boolean verifieValidite() {
    CListeObjets liste = frame.cadreActif().listePr;
    String rep = (String) getText();
    Bool definiApres = new Bool(false);
    pointeurValeur = liste.pointeurValeurReelleOuComplexe(rep, indiceMaxi, definiApres);
    if (definiApres.getValue()) {
    	setSelectionStart(0);
    	setSelectionEnd(getText().length());
    	requestFocus();
    	frame.dialogueAvertissement(MtgFrame.getString("ch73"));
    	return false;
    }
    else {
	    if (pointeurValeur != null) return true;
	    else { // Le champ d'dition ne contient pas une valeur dynamique dj cre
	    	frame.dialogueAvertissement(MtgFrame.getString("ch74"));
	    	return false;
	    }
    }
	}
}
