/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JTextArea;

import mathgraph32.MtgFrame;
import types.FonteNom;

/**
 * Bouton associ  un diteur et charg d'y insrer le code latex correspondant au caractre choisi
 * @author Yves
 *
 */
@SuppressWarnings("serial")
public class MtgCharButtonLatex extends JButton implements ActionListener {
	private PaneInsertionCaractere paneAssocie;
	@SuppressWarnings("unused")
	private int code; // Le code unicode du caractre
	private String chaineLatex; // la chane latex reprsentant le code
  private static Insets insets = new Insets(2,2,2,2);
  private static Insets insetshd = new Insets(4,4,4,4);
  private static final JButton refButton = new JButton("M");
  
	/**
	 * Constructeur par le code unicode du caractre
	 * @param code
	 */
	public MtgCharButtonLatex(int codeInit, String chaineLatexInit, PaneInsertionCaractere paneAssocieInit) {
		super(new String (Character.toString((char) codeInit)));
		setFont(FonteNom.getFonteNom(MtgFrame.sizeFontButton, FonteNom.Normal, MtgFrame.coefMultForSystemFonts));		
		// setMaximumSize(refButton.getPreferredSize()); Modifi version 5.0
		setMinimumSize(refButton.getPreferredSize());
		chaineLatex = chaineLatexInit;
		paneAssocie = paneAssocieInit;
    setMargin(MtgFrame.screenIsHighResolution ? insetshd : insets); // Modifi version 5.0
  	setFocusable(false); // Important pour viter que le dialogue de caractres spciaux soit raffich
  	//  chaque fois qu'on presse le bouton
		addActionListener(this);
		setFocusPainted(false);
	}
	
	public void actionPerformed(ActionEvent e) {
		JTextArea editeurAssocie = (JTextArea) paneAssocie.editeurAssocie;
    int i = editeurAssocie.getCaretPosition();
    String ch = editeurAssocie.getText();
    String ch2 = ch.substring(0, i) + chaineLatex + ch.substring(i);
    editeurAssocie.setText(ch2);
    editeurAssocie.requestFocus();
    editeurAssocie.setCaretPosition(i+chaineLatex.length());
    // On informa la fentre propruitaire qu'elle doit si ncessaire remettre  jour
    //l'affichage clignotant (pour CommentaireDlg et LatexDlg)
    MtgDlg owner = (MtgDlg) (editeurAssocie.getTopLevelAncestor());
    owner.metAJourAffichageClignotant();
	}
}
