/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

@SuppressWarnings("serial")
public class PaneOptionFigureElementsFiges extends PaneOptionsFigure {
	private MtgFrame frame;
	private MtgCheckBox checkMarquesAnglesFigees;
	private MtgCheckBox checkAffichagesFiges;
	
	/**
	 * Constructeur
	 */
	public PaneOptionFigureElementsFiges(MtgFrame frameInit, MtgInternalFrame cadreInit) {
		super(cadreInit);
		frame = frameInit;
		initComponents();
		checkMarquesAnglesFigees.setSelected(cadre.document.marquesAnglesFigees);
		checkAffichagesFiges.setSelected(cadre.document.affichagesFiges);
	}
	
	private final void initComponents() {
		checkMarquesAnglesFigees = new MtgCheckBox(frame, MtgFrame.getString("marquesAnglesFigees"));
		checkAffichagesFiges = new MtgCheckBox(frame, MtgFrame.getString("affichagesFiges"));
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		add(checkAffichagesFiges);
		add(checkMarquesAnglesFigees);
		setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));		
	}
	
	public boolean sauveDonnees() {
		cadre.document.marquesAnglesFigees = checkMarquesAnglesFigees.isSelected();
		cadre.document.affichagesFiges = checkAffichagesFiges.isSelected();
		return false;
	}	
	
	public String titreOnglet() {
		return MtgFrame.getString("ongletElementFiges");
	}
	
}
