/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

@SuppressWarnings("serial")
public class PaneOptionsFigureChampsEdition extends PaneOptionsFigure {
	private MtgCheckBox checkButtonValueAllowed;
	private MtgCheckBox checkButtonFunctionAllowed;

	public PaneOptionsFigureChampsEdition(MtgInternalFrame cadreInit) {
		super(cadreInit);
		initComponents();
		checkButtonValueAllowed.setSelected(cadre.document.buttonValueAllowed);
		checkButtonFunctionAllowed.setSelected(cadre.document.buttonFunctionAllowed);
	}

	private final void initComponents() {
		checkButtonValueAllowed = new MtgCheckBox(cadre.frame, MtgFrame.getString("buttonValueAllowed"));
		checkButtonFunctionAllowed = new MtgCheckBox(cadre.frame, MtgFrame.getString("buttonFunctionAllowed"));
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		add(checkButtonValueAllowed);
		add(checkButtonFunctionAllowed);
		setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));		
	}

	@Override
	public boolean sauveDonnees() {
		cadre.document.buttonValueAllowed = checkButtonValueAllowed.isSelected();
		cadre.document.buttonFunctionAllowed = checkButtonFunctionAllowed.isSelected();
		return false;
	}

	@Override
	public String titreOnglet() {
		return MtgFrame.getString("ongletOptionChampsEdition");
	}

}
