/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import javax.swing.JPanel;

import mathgraph32.MtgFrame;

@SuppressWarnings("serial")
public abstract class PaneOptionsPreferences extends JPanel {
	protected MtgFrame frame;
	
	/**
	 * Constructeur
	 */
	public PaneOptionsPreferences(MtgFrame frameInit) {
		frame = frameInit;
	}
	
	/**
	 * A redfinir pour tous les descendants
	 * Enregistrera les modifications dans la figure en cours
	 * Renverra true si des modifications ont t apportes
	 */
	public abstract void sauveDonnees();
	
	/**
	 * Fonction renvoyant true si les donnes de ce panneau sont valides.
	 * True par dfaut.
	 * Sera redfini pour la panneau de choix d'image de fond pour la figure
	 */
	public boolean donneesValides() {
		return true;
	}
	
	/**
	 * A redfinir pour tous les descendants
	 * Renverra le contenu de l'onglet correspondant
	 */
	public abstract String titreOnglet();
	
}
