/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;

import mathgraph32.MtgFrame;
import types.UniteAngle;

@SuppressWarnings("serial")
public class PanePreferencesChoixUniteAngle extends PaneOptionsPreferences {
	private MtgLabel label1;
	private MtgRadioButton radioRadian;
	private MtgRadioButton radioDegre;
	ButtonGroup btnGroup;
	
	/**
	 * Constructeur
	 */
	public PanePreferencesChoixUniteAngle(MtgFrame frameInit) {
		super(frameInit);
		initComponents();
		radioRadian.setSelected(frameInit.pref_angleUnit == UniteAngle.Radian);
		radioDegre.setSelected(frameInit.pref_angleUnit == UniteAngle.Degre);
	}
	
	private final void initComponents() {
		label1 = new MtgLabel(frame, MtgFrame.getString("uniteAnglePreferences"));
		radioRadian = new MtgRadioButton(frame, MtgFrame.getString("radioRadian"));
		radioDegre = new MtgRadioButton(frame, MtgFrame.getString("radioDegre"));
		btnGroup= new ButtonGroup();
		btnGroup.add(radioRadian);
		btnGroup.add(radioDegre);
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		add(label1);
		add(radioDegre);
		add(radioRadian);
		setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
	}
	
	public void sauveDonnees() {
		frame.pref_angleUnit  = radioRadian.isSelected() ? UniteAngle.Radian : UniteAngle.Degre;
	}
	
	public String titreOnglet() {
		return MtgFrame.getString("ongletUniteAngle");
	}	
	
	
}
