/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;

import mathgraph32.MtgFrame;
import types.FonteNom;

@SuppressWarnings("serial")
public class PaneTaillePolice extends JPanel {
	public JList<String> listeTailles;
	private JScrollPane scrollpane;
	public static final int taillePolicemax = 80;
	public static final int taillePolicemin = 10;

	public PaneTaillePolice(int taillePoliceInit) {
		super();
		listeTailles = new JList<String>();
		listeTailles.setFont(FonteNom.getFonteEdition(MtgFrame.sizeFontList, FonteNom.Normal, MtgFrame.coefMultForDlgBoxIcons));		

		Vector<String> vec = new Vector<String>();
		/* Modifi version 5.0 : On choisit maintenant la taille relle de la taille 8 jusqu' la taille 60
		vec.add(new String("8"));
		vec.add(new String("9"));
		vec.add(new String("11"));
		vec.add(new String("12"));
		vec.add(new String("14"));
		vec.add(new String("16"));
		vec.add(new String("18"));
		vec.add(new String("20"));
		vec.add(new String("22"));
		// Ajout de nouvelles tailles version 4.7.5.2
		for (int i = 24; i <= 60; i+=2) vec.add(Integer.toString(i));
		//
		*/
		for (int i = taillePolicemin; i <= taillePolicemax; i++) vec.add(Integer.toString(i));
		listeTailles.setListData(vec);
		listeTailles.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		listeTailles.setLayoutOrientation(JList.VERTICAL);
		listeTailles.setVisibleRowCount(4);
		// listeTailles.setSelectedIndex(taillePoliceInit); Modifi version 5.0
		listeTailles.setSelectedIndex(taillePoliceInit - 10);
		listeTailles.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
		scrollpane = new JScrollPane(listeTailles,
				JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
				JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		scrollpane.setBorder(BorderFactory.createEmptyBorder(2, 10, 2, 10));
		add(scrollpane);
		listeTailles.ensureIndexIsVisible(listeTailles.getSelectedIndex());
		setBorder(BorderFactory
				.createTitledBorder(MtgFrame.getString("paneTaillePolice1")));
	}

	/**
	 * Fonction renvoyant l'indice de la taille de police choisie
	 * Modifi version 5.0 : Renvoie maintenant la taille relle de la police
	 * @return
	 */
	public int indiceTaille() {
		// return listeTailles.getSelectedIndex();
		return listeTailles.getSelectedIndex() + 10;
	}

}
