/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import java.awt.Dimension;
import java.awt.FlowLayout;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JPanel;
import mathgraph32.MtgFrame;

@SuppressWarnings("serial")
public class ProduitScalaireDlg extends MtgDlg {
	public EditeurNomCalcul editeurNom;
	private MtgLabel label1; 
	private MtgButton btnOK, btnCancel;
	
  public ProduitScalaireDlg(MtgFrame frameInit) {
    super (getString("produitScalaireDlg1"), true, frameInit);
    initComponents();
    getRootPane().setDefaultButton(btnOK);
    editeurNom.requestFocus();
  }
	
	public void initComponents() {
		label1 = new MtgLabel(frame, getString("produitScalaireDlg2"));
		editeurNom = new EditeurNomCalcul(frame);
	  btnOK = new MtgButton(frame, getString("btnOK"));
	  btnOK.addActionListener(new java.awt.event.ActionListener() {
	    public void actionPerformed(java.awt.event.ActionEvent evt) {
	      btnOKActionPerformed();
	    }
	  });    
	  btnCancel = new MtgButton(frame, getString("btnCancel"));
	  btnCancel.addActionListener(new java.awt.event.ActionListener() {
	    public void actionPerformed(java.awt.event.ActionEvent evt) {
	      btnCancelActionPerformed();
	    }
	  });
	  btnOK.setMaximumSize(btnCancel.getPreferredSize());	
    JPanel paneRight = new JPanel();
    paneRight.setLayout(new BoxLayout(paneRight, BoxLayout.Y_AXIS));
    paneRight.add(btnOK);
    paneRight.add(Box.createRigidArea(new Dimension(0,5)));
    paneRight.add(btnCancel);
    getContentPane().setLayout(new FlowLayout());
    getContentPane().add(label1);
    getContentPane().add(editeurNom);
    getContentPane().add(paneRight);
    pack();
	}  

  private void btnOKActionPerformed() {
  	// On vrifie si le nom choisi pour la mesure est correct
    if (!frame.cadreActif().listePr.validationNomCalcul(frame, editeurNom.getText())) {
      editeurNom.requestFocus();
      return;
    }
  	setRetourOK(true);
  	dispose();
  }

  private void btnCancelActionPerformed() {
  	dispose();
  }	
}
