/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package mathgraph32;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import outils.Outil;
import actions.MtgAction;

/**
 *
 * @author Yves
 */
/**
 *
 * @author Yves
 * Type de bouton associ aux icones n'ayant qu'un seul tat.
 * Possde un pointeur sur l'outil associ
 * Descend de JToggleButton et non de JButton car c'est  moi de grer l'activation
 * ou non d'un bouton. Par exemple, si l'utilisateur clique sur un outilm qui ne peut pas tre
 * activ, il faut le dsactiver et activer l'outil de capture.
 * JToggleButton permet au bouton de changer son tat par SetSelected(boolean)
 *
 */
  
@SuppressWarnings("serial")
public class MtgActionButton extends JButton implements MouseListener {
  public MtgAction action;
  
  // private static Border margin = new EmptyBorder(1,1,1,1);
  // private static Insets insets = new Insets(1,1,1,1);
  
  /** Creates a new instance of MtgButton */
  public MtgActionButton(MtgAction actionInit) {
    super(actionInit);
    action = actionInit;
    // Ajout version 5.0
    if (action.dansBarreHorizontale) {
    	ImageIcon imi = action.imicon;
    	setIcon(new MtgImageIcon(action.frame.coefMultHorIcons(), imi));
    }
  	// setMargin(insets);
    setBorder(BorderFactory.createEtchedBorder());
    addMouseListener(this);
    setText(""); // Ajout version 4.6.3
  }

	public void mouseClicked(MouseEvent arg0) {
		
	}

	public void mouseEntered(MouseEvent arg0) {
		Outil outil = action.outilAssocie;
		if (outil != null) {
			if (outil.frame.cadreActif() != null) {
		    if (getCursor() != MtgFrame.defaultCursor) outil.frame.setCursor(MtgFrame.defaultCursor);
			}
		}
	}

	public void mousePressed(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	public void mouseReleased(MouseEvent arg0) {
		// TODO Auto-generated method stub
		setSelected(false); // Pas d'tat pour ce type de bouton
	}

	public void mouseExited(java.awt.event.MouseEvent e) {
		// TODO Auto-generated method stub
		
	}
}