/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package mathgraph32;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.net.URL;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JList;
import javax.swing.ListSelectionModel;

/**
 *
 * @author Yves
 */
// Modifi version 5.0
@SuppressWarnings("serial")
public class MtgListeStyleTrait extends JList<MtgImageIcon> implements MouseListener {
	private MtgFrame frame;
  /**
   * Constructeur
   */
	/* Modifi version 5.0 car on peut maintenant choisir le style de trait et l'paisseur.
  public MtgListeStyleTrait(MtgFrame frameInit) {
    super();
    frame = frameInit;
    setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    setLayoutOrientation(JList.VERTICAL);
    setVisibleRowCount(4);
    Vector<ImageIcon> vec = new Vector<ImageIcon>();
    URL adr = MtgFrame.class.getResource("images/TraitFin.gif");
    ImageIcon icon = new ImageIcon(adr);
    vec.add(icon);
    adr = MtgFrame.class.getResource("images/TraitPointilleFin.gif");
    icon = new ImageIcon(adr);
    vec.add(icon);
    adr = MtgFrame.class.getResource("images/TraitEpais.gif");
    icon = new ImageIcon(adr);
    vec.add(icon);
    adr = MtgFrame.class.getResource("images/TraitTraitFin.gif");
    icon = new ImageIcon(adr);
    vec.add(icon);
    adr = MtgFrame.class.getResource("images/TraitPointPointFin.gif");
    icon = new ImageIcon(adr);
    vec.add(icon);
    adr = MtgFrame.class.getResource("images/TraitTresEpais.gif");
    icon = new ImageIcon(adr);
    vec.add(icon);
    adr = MtgFrame.class.getResource("images/TraitPointilleEpais.gif");
    icon = new ImageIcon(adr);
    vec.add(icon);
    setListData(vec);
    setSelectedIndex(0);
    setToolTipText(MtgFrame.getString("tipChoixStyleTrait"));
    addMouseListener(this);
  }
*/
  public MtgListeStyleTrait(MtgFrame frameInit) {
    super();
    frame = frameInit;
    setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    setLayoutOrientation(JList.VERTICAL);
    setVisibleRowCount(6);
    setBorder(BorderFactory.createEmptyBorder(0,3,0,3));
    Vector<MtgImageIcon> vec = new Vector<MtgImageIcon>();
    URL adr = MtgFrame.class.getResource("images/TraitFin.png");
    double k = MtgFrame.coefMultForDlgBoxIcons;
    MtgImageIcon icon = new MtgImageIcon(k, adr);
    vec.add(icon);
    adr = MtgFrame.class.getResource("images/TraitPointilleFin.png");
    icon = new MtgImageIcon(k,adr);
    vec.add(icon);
    adr = MtgFrame.class.getResource("images/TraitTraitFin.png");
    icon = new MtgImageIcon(k,adr);
    vec.add(icon);
    adr = MtgFrame.class.getResource("images/TraitPointPointFin.png");
    icon = new MtgImageIcon(k,adr);
    vec.add(icon);
    adr = MtgFrame.class.getResource("images/TraitPointPointPointFin.png");
    icon = new MtgImageIcon(k,adr);
    vec.add(icon);
    adr = MtgFrame.class.getResource("images/TraitLongTraitFin.png");
    icon = new MtgImageIcon(k,adr);
    vec.add(icon);
    
    setListData(vec);
    setSelectedIndex(0);
    setToolTipText(MtgFrame.getString("tipChoixStyleTrait"));
    addMouseListener(this);
  }

  public int styleTrait() {
    return getSelectedIndex();
  }
	public void mouseClicked(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	public void mouseEntered(MouseEvent arg0) {
    if (getCursor() != MtgFrame.defaultCursor) frame.setCursor(MtgFrame.defaultCursor);
	}
	public void mouseExited(MouseEvent arg0) {
	}
	public void mousePressed(MouseEvent arg0) {
	}
	public void mouseReleased(MouseEvent arg0) {
	}

}
