/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/** Java:  Attention : cette classe n'existait pas dans la version C++
 * Modifi pour la version 1.8 :  cause des arcs d'images, CArcDeCercleAncetre
 * n'hrite plus de CCercleOA mais de CCercle
 * */
package objets;

import java.awt.Color;
import types.*;

// Modification pour la version 1.9.5
// A la suite du rajout des lieux d'objets cette classe n'est plus abstract
public class CArcDeCercleAncetre extends CCercle {
	// Ajout version 4.9.9 pour gnrer un nom
	public static int indice = 0;
	//
	double origine_x;
	double origine_y;
  double valeurAngleAuCentre;

  /** Creates new CArcDeCercleAncetre */
  public CArcDeCercleAncetre() {
  }
  
  // Constructeur pour clonage
  public CArcDeCercleAncetre(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    Color couleurInit, boolean masqueInit, StyleTrait styleInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit, masqueInit, styleInit);
  }
  

  @Override
  public void setClone(CElementBase ptel) {
    super.setClone(ptel);
    origine_x = ((CArcDeCercleAncetre)ptel).origine_x;
    origine_y = ((CArcDeCercleAncetre)ptel).origine_y;
    valeurAngleAuCentre = ((CArcDeCercleAncetre)ptel).valeurAngleAuCentre;
  }

  // Ajout version 4.9.9
  public String genereNom() {
  	indice++;
		return getString("rArc") + indice;
  }

  @Override
  public String complementInfo() {
    return getString("chinfo44");
  }
  
  
  @Override
  public long getNature() {
    return NatureObjet.NArc;
  }
  
  /** Renvoie la chaine que doit tre fugitivement affiche lorsque le pointeur souris
    * se rapproche d'un objet
    * Renvoie null s'il n'y a rien  afficher */
  public String chaineDesignation() {
    return getString("natArcDeCercle");
  }
}
