/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package objets;

import java.io.*;
import java.awt.Color;


import dialogs.MacroAnimationAvecTraceDlg;
import dialogs.MtgDlg;

import types.*;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;
import glob.*;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
/**
 * Dans la version logiciel java, listeDep est un membre dont les lments sont initialiss  la fin
 * du chargement d'une liste ou lors du clonage pour permettre le multitche.
 * @author Yves
 *
 */
public class CMacroAnimationAvecTrace extends CMacroAvecListe {
  public CPointLie pointLieAssocie;
	public boolean unSeulCycle;
	public boolean effacementFinCycle;
	public boolean animationCyclique;
  public int frequenceAnimationMacro;
  public int nombrePointsPourAnimation;
	public int dureeAnimation; // Dure en secondes (0 si animation
											// jusqu' clic de souris)
	private CListeObjets listeDep;
  private double abscisseInitiale;
  private double abscisse; // l'abscisse en cours du point li qui bouge
  private double abscisseMini;
  private double abscisseMaxi;
  private double pas;
  // Membre n'existant pas dans la version C++ : sert  savoir si on est arriv
  // en fin de boucle et s'il faut effacer les traces 
  boolean effacementTraces;
  // Ajouts version 4.9.8
  public boolean retourDepart;
  public boolean inverserSens;

  /** Creates new CMacroAnimationAvecTrace */
  public CMacroAnimationAvecTrace() {
  }
  
  // Version 4.9.8. On change le numro de version.
  // On rajoute la possibilit de demander que le point mobile ne soit pas remis  son emplacement de dpart  la fin de l'animation,
  // et de demander un dplacement dans le sens inverse.
  @Override
  public int numeroVersion() {
  	return 2;
  }  

  // Constructeur pour clonage
  public CMacroAnimationAvecTrace(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      Color couleurInit, double x_nomInit, double y_nomInit, double dec_xInit, double dec_yInit,boolean masqueInit,
      CPointAncetre pointLieInit, int indiceTaillePoliceInit, int encadrementInit,
      boolean effacementFondInit, Color couleurFondInit, String intituleInit, String commentaireMacroInit,
      CSousListeObjets listeAssocieeInit, CPointLie pointLieAssocieInit, boolean unSeulCycleInit,
      boolean effacementFinCycleInit, boolean animationCycliqueInit,int frequenceAnimationMacroInit,
      int nombrePointsPourAnimationInit, int dureeAnimationInit, int alignementHorizontalInit, int alignementVerticalInit,
      boolean retourDepartInit, boolean inverserSensInit) {
        super (liste, impProtoInit, estElementFinalInit, couleurInit, x_nomInit, y_nomInit,
          dec_xInit, dec_yInit, masqueInit, pointLieInit, indiceTaillePoliceInit, encadrementInit,
          effacementFondInit, couleurFondInit, intituleInit, commentaireMacroInit, listeAssocieeInit,
          alignementHorizontalInit, alignementVerticalInit);
    pointLieAssocie = pointLieAssocieInit;
    unSeulCycle = unSeulCycleInit;
    effacementFinCycle = effacementFinCycleInit;
    animationCyclique = animationCycliqueInit;
    frequenceAnimationMacro = frequenceAnimationMacroInit;
    nombrePointsPourAnimation = nombrePointsPourAnimationInit;
    dureeAnimation = dureeAnimationInit; // Dure en secondes (0 si animation
    retourDepart = retourDepartInit;
    inverserSens = inverserSensInit;
    listeDep = new CListeObjets(liste);
  }

  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    CSousListeObjets listeAssocieeClone = new CSousListeObjets();
    listeAssocieeClone.setImage(listeAssociee, listeSource, listeCible);
    int ind1 = listeSource.indexOf(pointLieAssocie);    
    int ind2 = listeSource.indexOf(pointLie);
    int ind3 = listeSource.indexOf(impProto);        
    CElementBase ptelb = new CMacroAnimationAvecTrace(listeCible,
    		(CImplementationProto)(listeCible.get(ind3, CImplementationProto.class)),
      estElementFinal, couleur, x_nom, y_nom, dec_x, dec_y, masque,
      (CPointAncetre)listeCible.get(ind2, CPointAncetre.class), indiceTaillePolice, 
      encadrement, effacementFond, couleurFondAffichage, intitule, commentaireMacro, listeAssocieeClone,
      (CPointLie) (listeCible.get(ind1, CPointLie.class)), unSeulCycle , effacementFinCycle,
      animationCyclique, frequenceAnimationMacro , nombrePointsPourAnimation,
      dureeAnimation, alignementHorizontal, alignementVertical, retourDepart, inverserSens);
    ((CMacroAnimationAvecTrace)ptelb).listeDep = new CListeObjets(listeCible);
    return ptelb;
  }
  
  @Override
  public boolean dependDe(CElementBase p) {
  	if (elementTestePourDependDe == p) return dependDeElementTeste;
    return memoriseDependance(super.dependDe(p) || pointLieAssocie.dependDe(p));
  }

  // Modifi version 4.8
  @Override
  public boolean dependDePourReclassement(CElementBase p) {
  	if (elementTestePourDependDePourRec == p) return dependDeElementTestePourRec;
    return memoriseDependancePourRec(super.dependDePourReclassement(p) || pointLieAssocie.dependDePourReclassement(p));
  }
  
  @Override
  public boolean dependDePourBoucle(CElementBase p) {
    return super.dependDePourBoucle(p) || pointLieAssocie.dependDePourBoucle(p);
  }

  @Override
  public int typeAnimation() {
    return CMacro.animationParTimer;
  }
  
  @Override
  public int frequenceAnimation() {
    return frequenceAnimationMacro;
  }
  
  @Override
  public long dureePourAnimation() {
    return unSeulCycle ? 1 : dureeAnimation;
  }
  
  @Override
  public boolean arretParClic() {
  	// Modifi version 3.2.4.3
  	return (dureeAnimation == 0) || unSeulCycle;
  }
  
  @Override
  public void metAJour() {
  	super.metAJour();
  	etablitListesInternes();
  }
  
  /**
   * Fonction prparant les listes dont la macro a besoin pour s'excuter
   */
  @Override
  public void etablitListesInternes() {
  	listeDep.retireTout();
    listeDep.ajouteObjetsDependantsSauf(pointLieAssocie, listeProprietaire, this);
  }
  
  
  @Override
  public void actionAvantExecution(MtgInternalFrame cadre) {
  	super.actionAvantExecution(cadre);  // Met executionEnCours  true
    // Rajout pour version 1.8
    cadre.initialisetbuffer();   
    // On mmorise la position actuelle du point li
    abscisseInitiale = pointLieAssocie.abscisse;
    abscisseMini = pointLieAssocie.abscisseMinimale();
    abscisseMaxi = pointLieAssocie.abscisseMaximale();
    if (abscisseMini > abscisseMaxi) {
      double d = abscisseMini;
      abscisseMini = abscisseMaxi;
      abscisseMaxi = d;
    }
    
    if (pointLieAssocie.lieALigneFermee()) pas = (abscisseMaxi-abscisseMini)/nombrePointsPourAnimation;
    else pas = (abscisseMaxi-abscisseMini)/(nombrePointsPourAnimation - 1);
    // Modifi version 4.9.8
    if (inverserSens) pas = -pas;
    // abscisse = abscisseMini - pas;
    // Corrig version 4.9.9.3
    // abscisse = unSeulCycle ? (inverserSens ? abscisseMaxi-pas : abscisseMini-pas) : abscisseMini-pas;
    abscisse = unSeulCycle ? (inverserSens ? abscisseMaxi+pas : abscisseMini-pas) : abscisseInitiale;
    //
    timeDebut = System.currentTimeMillis();
    // Si l'animation doit durer un seul cycle, on leurerra paint() en
    // mettant timeFin  timeDebut quand la boucle sera finie
    if (unSeulCycle) timeFin = timeDebut + 100000000;
    else {
      if (dureeAnimation != 0)
        timeFin = timeDebut + dureeAnimation*100; // La dure est en diximes de secondes
    }
    effacementTraces = false;
  }

  // La fonction suivante a t amliore pour la version 1.9.5 pour ne pas sauter de traces
  // aux valeurs limites
  // synchronized depuis la version 3.2.5.1 car executePourTimer peut tre appel au milieu de paint
  // et vice-versa
  @Override
  public synchronized void executePourTimer(MtgInternalFrame cadre, boolean repaint) {
    double d;
    if (!executionEnCours) return;
    DimensionFenetre dimf = cadre.dimf;
    abscisse = abscisse + pas;
    if (Kernel.zero13(abscisse-abscisseMaxi)) abscisse = abscisseMaxi;
    else 
    	if (Kernel.zero13(abscisse-abscisseMini)) abscisse = abscisseMini;
    if (unSeulCycle) {
      // Modifi version 4.9.8
      d = inverserSens ? abscisse - abscisseMini : abscisse - abscisseMaxi;
      if (inverserSens) {
      	if (d<0) {
        	timeFin = timeDebut; // Pour que dans paint on appelle termineAction()
        	abscisse = abscisseMini;
        	// Ainsi paint va tre appel pour la dernire position et mme s'il est saut
        	// il sera appel une fois suivante et alors dans MtgPaneFigure termineAction sera appel
        }          	
      }
      else if (d>0) {
      	timeFin = timeDebut; // Pour que dans paint on appelle termineAction()
      	abscisse = abscisseMaxi;
      	// Ainsi paint va tre appel pour la dernire position et mme s'il est saut
      	// il sera appel une fois suivante et alors dans MtgPaneFigure termineAction sera appel
      }    
    }
    else  {
      if (animationCyclique) {
      	// Modifi version 4.9.8
      	if (inverserSens) {
      		if (abscisse < abscisseMini) {
            abscisse = abscisseMaxi;
            if (effacementFinCycle) effacementTraces = true;     		
      		}
      	}
      	else if (abscisse > abscisseMaxi) {
          abscisse = abscisseMini;
          if (effacementFinCycle) effacementTraces = true;
        }
      }
      else {
      	// Modifi version 4.9.8
      	// Corrig version 4.9.9.2
    		if (abscisse < abscisseMini) {
          pas = -pas;
          abscisse = abscisseMini;
          if (effacementFinCycle) effacementTraces = true;
      	}
      	else if (abscisse > abscisseMaxi) {
          pas = -pas;
          abscisse = abscisseMaxi;
          if (effacementFinCycle) effacementTraces = true;
        }
      }
    }
    if (effacementTraces) {
      cadre.initialisetbuffer();   
      effacementTraces = false;
    }
	  pointLieAssocie.donneAbscisse(abscisse);
    // On dplace le point li vers sa nouvelle position
    listeDep.positionne(cadre.infRand, dimf);
    // Les objets devant laisser une trace le font dans le buffer de traces.
    CMathGrafDoc doc= cadre.document;
    listeAssociee.afficheToutMemeMasquesPourTrace(cadre.tbuffer, dimf, doc.couleurFond, doc.transparencePourSurfaces, cadre.frame.pref_antialiasing);
    if (repaint) cadre.paneFigure.repaint();
  }
  
  // synchronized depuis la version 3.2.5.1 car executePourTimer peut tre appel au milieu de paint
  // et vice-versa
  @Override
  public synchronized void actionDansPaint(MtgInternalFrame cadre) {
    // Les objets devant laisser une trace le font dans le buffer de traces.
    // listeAssociee.afficheToutMemeMasques(applet.tbuffer, dimfen);
    // On transfere le buffer de traces dans le buffer mmoire (gbuffer)
    cadre.transferetbufferversgbuffer();
    //listeDep.effaceTout(applet.gbuffer, dimfen);
    // On raffiche la figure complte
    cadre.afficheToutDansgbuffer();
  }

  // Modifi version 3.1.7
  @Override
  public boolean executionPossible() {
  	// Modifi version 3.2.4.3
    // return pointLieAssocie.existe && listeAssociee.existeAuMoinsUnElement();
  	return pointLieAssocie.existe;
  }

  @Override
  public void termineAction(MtgInternalFrame cadre) {
    super.termineAction(cadre);
    boolean infr = cadre.infRand;
    DimensionFenetre dimfen = cadre.dimf;
    // listeDep.effaceTout(cadre.gbuffer, dimfen, true, doc.couleurFond, doc.transparencePourSurfaces);
    if (retourDepart) pointLieAssocie.donneAbscisse(abscisseInitiale);
    listeDep.positionne(infr, dimfen);
    // cadre.effacegbuffer();
    cadre.transferetbufferversgbuffer();
    cadre.afficheToutDansgbuffer();
    // TermineAction n'est pas appel dans Paint()
    // mais dans MousePressed. Impossible de lancer un rapint() pour ne pas
    // perdre les traces. Il faut donc transfrer le gbuffer directement
    // sur le DeviceContext de l'applet.
    cadre.paneFigure.repaint();
  }
  @Override
  public String infoPourHistorique() {
    String ch = nom() + " : " + getString("chinfo124") + " " + pointLieAssocie.nom() + "\n" + getString("chinfo125");
    ch += "\n" + getString("macroApparitionDlg2") + " " + intitule;
  	if (pointLie != null) ch += "\n" + getString("chinfo200") + " " + pointLie.nom();
  	if (effacementFond) ch += "\n" + getString("paneAffichage1");
  	ch += "\n" + getString("chinfo231") + listeAssociee.listeNoms();
  	return ch;
  }
  
 	/**
 	 * Fonction renvoyant la chane courte dcrivant l'objet dans certaines listes de botes de dialogues.
 	 * A redfinir pour les descendants.
 	 * @return
 	 */
   @Override
 	public String info() {
     return nom() + " : " + getString("chinfo124") + " " + pointLieAssocie.nom() + " " + getString("chinfo125");
 	}

  @Override
  public void ajouteAntecedents(MtgFrame frame, CListeObjets liste) {
  	liste.add(pointLieAssocie);
    liste.ajouteElementsDe(listeAssociee);
  }
  
  @Override
  public void remplacePoint(CPointAncetre ancienPoint, CPointAncetre nouveauPoint) {
  	if (pointLieAssocie == ancienPoint) pointLieAssocie = (CPointLie) nouveauPoint;
  	// Suprim version 2.0 car provoques des stackoverflow
  	// listeDep.remplacePoint(ancienPoint, nouveauPoint);
  }
  
  
  @Override
	public boolean estDefiniParObjetDans(CListeObjets listeOb) {
		return 	super.estDefiniParObjetDans(listeOb)
			&& (listeOb.contains(pointLieAssocie) || pointLieAssocie.estDefiniParObjetDans(listeOb));
	}
  
  @Override
  public boolean modifiableParMenu() {
  	// Modification version 4.5.1
  	// return !estElementFinal;
  	return true;
  }
  
   @Override
  public MtgDlg dialogueModification(MtgFrame frame) {
  	return new MacroAnimationAvecTraceDlg(frame, this, true);
  }
  
 	/**
 	 * Fonction renvoyant true si l'objet dpend des positions gnres pas les dplacements d'un point li
 	 * A redfinir pour les lieux de points et lieux d'objets et macros utilisant les dplacements d'un point li
 	 * @param pointlie
 	 * @return
 	 */
   @Override
 	public boolean estGenereParPointLie(CPointLie pointlie) {
 		return pointLieAssocie == pointlie;
 	}
   
  
  @Override
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
		unSeulCycle = inps.readBoolean();
		effacementFinCycle = inps.readBoolean();
		animationCyclique = inps.readBoolean();
		frequenceAnimationMacro = inps.readCInt();
    // Frquence  vitesse maxi remplace par 1/1000 de seconde
    if (frequenceAnimationMacro == 0) frequenceAnimationMacro = 1;
		nombrePointsPourAnimation = inps.readCInt();
		dureeAnimation = inps.readCInt();
    int ind1 = inps.readCInt();
    pointLieAssocie = (CPointLie) (list.get(ind1,CPointLie.class));
		// Ajout version 4.9.8
  	inverserSens = false;
  	retourDepart = true;
		//
    listeDep = new CListeObjets(list.uniteAngle, list.pointeurLongueurUnite);
    // Pour arrter la macro quand elle n'effectue qu'un seul cycle
    // il ne faut pas que durreAnimation soit nul;
    if (unSeulCycle) dureeAnimation = 1;
    if (list.getClass() != CPrototype.class) {
    	listeDep = new CListeObjets(listeProprietaire);
    }
  }

  @Override
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
		unSeulCycle = inps.readBoolean();
		effacementFinCycle = inps.readBoolean();
		animationCyclique = inps.readBoolean();
		frequenceAnimationMacro = inps.readInt();
    // Frquence  vitesse maxi remplace par 1/1000 de seconde
    if (frequenceAnimationMacro == 0) frequenceAnimationMacro = 1;
		nombrePointsPourAnimation = inps.readInt();
		dureeAnimation = inps.readInt();
    int ind1 = inps.readInt();
    pointLieAssocie = (CPointLie) (list.get(ind1,CPointLie.class));
    if (nVersion < 2) {
    	retourDepart = true;
    	inverserSens = false;
    }
    else {
    	retourDepart = inps.readBoolean();
    	inverserSens = inps.readBoolean();
    }
    listeDep = new CListeObjets(list.uniteAngle, list.pointeurLongueurUnite);
    // Pour arrter la macro quand elle n'effectue qu'un seul cycle
    // il ne faut pas que dureeAnimation soit nul;
    if (unSeulCycle) dureeAnimation = 1;
    if (list.getClass() != CPrototype.class) {
    	listeDep = new CListeObjets(listeProprietaire);
    }
  }  

  @Override
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    oups.writeBoolean(unSeulCycle);
    oups.writeBoolean(effacementFinCycle);
    oups.writeBoolean(animationCyclique);
    oups.writeInt(frequenceAnimationMacro);
    oups.writeInt(nombrePointsPourAnimation);
    oups.writeInt(dureeAnimation);
    int ind1 = list.indexOf(pointLieAssocie);
    oups.writeInt(ind1);
    // Ajout version 4.9.8
    oups.writeBoolean(retourDepart);
    oups.writeBoolean(inverserSens);
  }
}
