/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import objets.CAffichageLieAPoint;
import objets.CListeObjets;
import objets.CValeurAffichee;
import types.StyleEncadrement;
import dialogs.AffichageValeurDlg;
import mathgraph32.MtgFrame;

public class OutilAffichageValeurLiePoint extends OutilParPoint {
	/** Constructeur */
	public OutilAffichageValeurLiePoint(MtgFrame frameInit) {
		super(frameInit);
	}

  @Override
  public void creeObjet() {
  	CListeObjets liste = frame.cadreActif().listePr;
  	// Bug ci=orrig version 5.0.0.2
  	/*
    CValeurAffichee affval = new CValeurAffichee(liste, null, false, frame.couleurActive(),
    		0d, 0d, 0d, 6d, false, point, frame.pref_IndiceTaillePoliceAffichages, StyleEncadrement.Sans, false,
    		frame.cadreActif().couleurFondAffichage, null, "", "", (int)(MtgFrame.coefMultForDlgBoxIcons*13),
				CAffichageLieAPoint.alignementHorizontalCentre, CAffichageLieAPoint.alignementVerticalHaut);
		*/
    CValeurAffichee affval = new CValeurAffichee(liste, null, false, frame.couleurActive(),
    		0d, 0d, 0d, 6d, false, point, frame.pref_IndiceTaillePoliceAffichages, StyleEncadrement.Sans, false,
    		frame.cadreActif().couleurFondAffichage, null, "", "", 2,
				CAffichageLieAPoint.alignementHorizontalCentre, CAffichageLieAPoint.alignementVerticalHaut);

    AffichageValeurDlg dlg = new AffichageValeurDlg(frame, affval, false);
		dlg.setLocationRelativeTo(frame);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
	    if (frame.ajouteElementAvecVerification(affval)) {
	    	annuleClignotement();
	      frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil53"));
	      frame.cadreActif().repaintFigureAvecCalcul();
	    }
    }
    annuleClignotement();
    select();
  }
  
  @Override
  public String chaineIndication(int indEtape) {
    switch(indEtape) {
      case 1 : return getString("affichageValeurLiePoint1");
      default: return "";
    }
  }
}