/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import objets.CGrandArcDeCercle;
import objets.CListeObjets;
import mathgraph32.MtgFigurePanel;
import mathgraph32.MtgFrame;

public class OutilArcGrandParPointFinal extends OutilPar3pts {
  public OutilArcGrandParPointFinal(MtgFrame frameInit) {
    super(frameInit);
  }
	/**
	 * Ajout versions 5.0.
	 * Renverra true si on peut crer un point quand on clique sur un endroit vide de la figure.
	 * Devra tre redfini pour les outils pour lesquels ce n'est pas possible comme les outils de mesure.
	 * @return
	 */
	protected boolean creationPointPossible() {
		return true;
	}

  @Override
  public void creeObjet() {
    CGrandArcDeCercle pt = new CGrandArcDeCercle(frame.cadreActif().listePr, null, false, 
       frame.couleurActive(), false, frame.styleTraitActif(), point1, point2, point3, null);
    if (frame.ajouteElementAvecVerification(pt))
      frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil29"));
    annuleClignotement();
    // Provisoire
    select();
  }

  @Override
  public void ajouteObjetsVisuels() {
    CListeObjets liste = frame.listeObjetsVisuels;
    MtgFigurePanel pane = frame.cadreActif().paneFigure;
    CGrandArcDeCercle mar = new CGrandArcDeCercle(liste, null, false, frame.couleurActive(),
      false, frame.styleTraitActif(), point1, point2, pane.pointSouris, null);
    liste.add(mar);
  }  
  @Override
  public String chaineIndication (int indEtape) {
    switch (indEtape) {
      case 1 : return getString("arcPetitParPointFinal1");
      case 2 : return getString("arcPetitParPointFinal2");
      case 3 : return getString("arcPetitParPointFinal3");
      default: return "";
    }
  }	

}
