/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import objets.CDemiPlan;
import mathgraph32.MtgFrame;

public class OutilDemiPlan extends OutilParDtPt {
  public OutilDemiPlan(MtgFrame frameInit) {
    super(frameInit);
  }
  
  @Override     
  public void creeObjet() {
    CDemiPlan dp = new CDemiPlan(frame.cadreActif().listePr, null,
       false, frame.couleurActive(), false, frame.styleRemplissageActif(), droite1, point1);
    if (frame.ajouteElementAvecVerification(dp))
      frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil71"));
    annuleClignotement();
    frame.activeOutilCapture();
  }

  @Override     
  public String chaineIndication (int indEtape) {
    switch(indEtape) {
      case 1 : return getString("demiPlan1");
      case 2 : return getString("demiPlan2");
      default: return "";
    }
  }
}
