/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import objets.CDroite;
import objets.CDroiteParEq;
import objets.CListeObjets;
import types.NatureCalcul;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import dialogs.DroiteParEquationDlg;

public class OutilDroiteParEquation extends Outil {

  public OutilDroiteParEquation(MtgFrame frameInit) {
    super(frameInit, false);
  }
  
  @Override
  public void select() {
    super.select();
    MtgInternalFrame cadre = frame.cadreActif();
    frame.indication("");
    CDroiteParEq droite = new CDroiteParEq(cadre.listePr, null, false, frame.couleurActive(), false, 0, 0, false, "",
    		frame.pref_indiceTaillePoliceNom, frame.styleTraitActif(), CDroite.abscisseNomParDefaut);    
    DroiteParEquationDlg dlg = new DroiteParEquationDlg(frame, droite, false);
		dlg.setLocationRelativeTo(frame);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
      if (frame.ajouteElementAvecVerification(droite))
        cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil145"));
      frame.cadreActif().repaintFigureAvecCalcul();
      frame.activeOutilCapture();
    }
  }
  
  @Override
	public boolean activationValide() {
		CListeObjets liste = frame.cadreActif().listePr;
		return (liste.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NRepere)!=0);
	}
	
	@Override
	public String messageActivationNonValide() {
		CListeObjets liste = frame.cadreActif().listePr;
		if (liste.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NRepere)==0) return getString("messagePasDeRepere");
		else return "";
	}	  
}
