/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import mathgraph32.MtgFrame;
import types.NatureObjet;
import dialogs.ModificationMacroDlg;

public class OutilModificationMacro extends Outil {
	
	public OutilModificationMacro(MtgFrame frameInit) {
		super(frameInit, false);
	}

  @Override
	public void select() {
		super.select();
		ModificationMacroDlg dlg = new ModificationMacroDlg(frame);
		dlg.setLocationRelativeTo(frame);
		dlg.setVisible(true);
		frame.activeOutilCapture();
	}

  @Override
  public boolean activationValide() {
    return (frame.cadreActif().listePr.nombreObjetsParNature(NatureObjet.NMacro) != 0);
  }
  
	@Override
	public String messageActivationNonValide() {
		return getString("messagePasDeMacro");
	}	
}
