/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;
import java.awt.geom.*;

import objets.*;
import types.Doub;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;


/**
 *
 * @author Yves
 */
public class OutilPointageRapporteur extends OutilPointage {
  CPointLieCercle ptPointLieCercle = null;
  // Le pointabs contient la nouvelle abscisse d'un point
  // li qui doit tre dplac
  public static Doub pointabs = new Doub();
  // pointres contient les nouvelles coordonnes d'un point libre qui doit tre dplac
  public static Point2D.Double pointres = new Point2D.Double();
  
  /** Creates a new instance of OutilPointageRapporteur */
  public OutilPointageRapporteur(MtgFrame frameInit) {
    super(frameInit);
  }

  /** Fonction mettant dans ptPointLie un pointeur sur le pointli  un cercle que l'outil
   * est charg de faire bouger
   */
  public final void associePointLie(CPointLieCercle ptInit) {
    ptPointLieCercle = ptInit;
  }
  
  @Override
  public void reset() {
    super.reset();
    ptPointLieCercle = null;
    frame.cadreActif().videDesignation();
  }
  
  @Override
  public void mouseClicked(java.awt.event.MouseEvent mouseEvent, MtgInternalFrame cadre) {
  }
  
  @Override
  public void mouseMoved(java.awt.event.MouseEvent mouseEvent, MtgInternalFrame cadre) {
    
    boolean poss = ptPointLieCercle.testDeplacement(cadre.dimf,mouseEvent.getX(),
      mouseEvent.getY(), pointres, pointabs);
    if (poss)
    {
      ptPointLieCercle.donneAbscisse(pointabs.getValue());
      //appletMere.positionneListeVisuelle();
      cadre.paneFigure.repaint();
    }
  }
  @Override
  public void mousePressed(java.awt.event.MouseEvent mouseEvent, MtgInternalFrame cadre) {
    frame.outilActif.creeObjet();
  }
  
  @Override
  public void mouseDragged(java.awt.event.MouseEvent mouseEvent, MtgInternalFrame cadre) {

  }
  @Override
  public void mouseReleased(java.awt.event.MouseEvent mouseEvent, MtgInternalFrame cadre) {
  }

}
