/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

public class OutilReafficherTout extends Outil {

  public OutilReafficherTout(MtgFrame frameInit) {
    super(frameInit, false);
  }
	
  @Override
  public void select() {
    super.select();
    MtgInternalFrame cadre = frame.cadreActif();
    // autorisation des tirages alatoires
    cadre.infRand = true;
    cadre.effacegbuffer();
    cadre.effacetBuffer(); // Ligne rajoute version 4.4.4 pour effacer les traces
    // cadre.repaintFigureAvecCalcul(); // Modifi version 4.9.3.1
    cadre.repaintFigureAvecCalculFull();
    cadre.infRand = false;
    frame.activeOutilCapture();
  }
  
}
