/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import java.awt.Cursor;
import java.awt.Point;
import mathgraph32.MtgFrame;
import objets.CElementGraphique;
import objets.CElementLigne;
import objets.CSurfaceAncetre;
import types.NatureObjet;
/**
 * 
 * @author Yves
 * Ajout version 5.0
 * Quand on clique sur un objet, cet outil adapte les styles de trait, couleur, remplissage etc ...  partir de cet objet
 * 
 */
public class OutilRecopierStyle extends Outil {
	public CElementGraphique objetDesigne;
	/** Creates a new instance of OutilPtLib */
	public OutilRecopierStyle(MtgFrame frameInit) {
		super(frameInit, false);
	}

	@Override
  public Cursor curseurUtilise() {
		return MtgFrame.defaultCursor;
	}

  @Override
	public void select() {
		super.select();
		frame.outilPointageActif = frame.outilPointageCre;
		frame.outilPointageActif.designationDe(NatureObjet.NToutObjetSaufRepere);
		frame.indication(getString("recopierStyle1"));
	}
  
	public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
  	objetDesigne = elg;
		creeObjet();
	}
	@Override
	public void creeObjet() {
		frame.setColor(objetDesigne.couleur);
		if (objetDesigne.estDeNature(NatureObjet.NObjetLigne)) {
			frame.setStyleTrait(((CElementLigne)objetDesigne).style);
		}
		if (objetDesigne.estDeNature(NatureObjet.NSurface)) {
			frame.setStyleRemplissage(((CSurfaceAncetre)objetDesigne).styleRemplissage);
		}
  	frame.activeOutilPalette();
	}
}
