/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import java.awt.Point;

import objets.CElementGraphique;
import objets.CLieuDeBase;
import objets.CSurfaceDeuxLieux;
import types.NatureObjet;

import mathgraph32.MtgFrame;

/**
 * Outil de cration d'une surface dlimite par deux lieux de points relis
 * @author Yves
 *
 */
public class OutilSurfaceDeuxLieux extends Outil {
		private CLieuDeBase lieu1;
		private CLieuDeBase lieu2;
		
		public OutilSurfaceDeuxLieux(MtgFrame frameInit) {
			super(frameInit, true);
		}

	  @Override
		public void select() {
			super.select();
			lieu1 = null;
			lieu2 = null;
			frame.outilPointageActif = frame.outilPointageCre;
			frame.outilPointageActif.designationDe(NatureObjet.NLieu);
			frame.indication(getString("surfaceDeuxLieux1"));
		}

		/*
		 * Appel lorsqu'un objet a t cliqu pour tre trait par l'outil par
		 * exemple le premier point pour crer une droite passant par deux points
		 */
		public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
	    if (lieu1 == null) {
	      lieu1 = (CLieuDeBase) elg;
	      ajouteClignotementDe(lieu1);
	      resetClignotement();
	      excluDeDesignation(lieu1);
	      frame.indication(getString("surfaceDeuxLieux2"));
	    }
	    else {
	    	lieu2 = (CLieuDeBase) elg;
	    	creeObjet();
	    }
		}

	  @Override
		public void creeObjet() {
	    CSurfaceDeuxLieux pt = new CSurfaceDeuxLieux(frame.cadreActif().listePr, null,
	        false, frame.couleurActive(), false, frame.styleRemplissageActif(), lieu1, lieu2);
	    if (frame.ajouteElementAvecVerification(pt))
	       frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil38"));
	   	annuleClignotement();
	   	select();
	  }
}
